using System;
using System.Windows.Forms;
using System.Windows.Threading;
using Application=System.Windows.Application;

namespace Hardcodet.LiveWriter.ApplyCssPlugin
{
  public static class PopupManager
  {
    private static ClassBrowser popup;


    public static string RequestClassName(PluginSettings settings)
    {
      if (popup == null)
      {
        popup = new ClassBrowser(settings);
      }

      popup.ClassName = null;

      popup.IsOpen = true;
      WinApi.ActivatePopup(popup);

      Cursor.Current = Cursors.WaitCursor;

      while (popup.IsOpen)
      {
        System.Windows.Forms.Application.DoEvents();
      }

      return popup.ClassName;
    }


    public static void Invoke(Action action)
    {
      Dispatcher dispatcher = GetDispatcher();
      dispatcher.Invoke(action);
    }

    private static Dispatcher GetDispatcher()
    {
      return Application.Current != null
                 ? Application.Current.Dispatcher
                 : Dispatcher.CurrentDispatcher;
    }
  }
}